program exercise12a
  implicit none

  integer :: n

  do n = 1, 30

     print *, "n = ", n, " n! = ", factorial(n)  

  end do

  
contains 

  !再帰関数はrecursiveをつける。また関数の返す値はresultの後に記述
  recursive function factorial(n) result(fact)  
    integer, intent(in) :: n 
    integer :: k
    double precision :: fact ! 関数の戻り値に関数名は使えない。

    fact = 0.0d0   
    if(n .lt. 0) return

    fact = 1.0d0  
    if(n .eq. 0) return

    ! ここまで来る処理はnが正の場合

    ! 階乗n! を n * (n-1)!として計算。 (n-1)!の計算のためにfactorial()を再帰的に呼び出す
    fact = n * factorial(n-1) 

    return 
    
  end function factorial
    
end program exercise12a
